
/**
	HTTPQuery http;
	http.Query("http://etc.topaccess.com/request.php", HTTP_POST, NULL);
*/

#include "stdafx.h"
#include "Winsock2Layer.h"
#include "HTTPQuery.h"
#include "_library.h"



CHTTPQuery::CHTTPQuery()
{

	_retstr = NULL;

}




CHTTPQuery::~CHTTPQuery()
{

	
	if ( _retstr ) {
		free( _retstr );
		_retstr = NULL;
	}
}


/**
	HTTP     ְ, HTML  Ѵ.
@param method
	false ̸ GET
	true ̸ POST
	⺻ false ̴.

@note
*/
const char *CHTTPQuery::Query(const char *host, const char *path, const char *data, int port, bool method)
{

	
	if ( _retstr ) {
		free( _retstr );
		_retstr = NULL;
	}

	CString q, query;
	if ( method == false ) {
		q = path;
		q += "?";
		q += data;
		q.Replace(" ", "+");
		query.Format("GET %s HTTP/1.0\r\n\r\n", q);
	}


	WinSock2Layer _sock;

	_sock.SetAddress(host);
	TRACE(_sock.GetErrorString());

	_sock.SetPort(port);
	TRACE(_sock.GetErrorString());

	_sock.SetTimeout( 60000 );
	TRACE(_sock.GetErrorString());

	if ( _sock.Connect() ) {
		TRACE("in CHTTPQuery: %s\r\n", _sock.GetErrorString());
		return NULL;
	}


	_sock.Send(query);

	const char *ptr = NULL;
	
	

	if ( ( ptr = _sock.Recv() ) == NULL ) return NULL;

	int len;
	len = strlen( ptr );
	_retstr = (char *) malloc( len + 1 );
	if ( _retstr == NULL ) 
		return NULL;
	strcpy( _retstr, ptr );

	while ( ( ptr = _sock.Recv() ) != NULL ) {
		_retstr = (char *) realloc( _retstr, strlen(_retstr) + strlen(ptr) + 1 );
		if ( _retstr == NULL ) 
			return NULL;
		strcat( _retstr, ptr );
	}
	_sock.Close();



	if ( _retstr == NULL ) return NULL;
	const char *page = FindPage( _retstr );

	return page;
}



/**
@note	 ϴ 
	\r\n\r\n ̳ \n\r\n\r   \r\n   ̻ ־Ѵ.

*/
const char *CHTTPQuery::FindPage( const char *ptr )
{
	if ( ptr == NULL ) return NULL;
	int cntlf=0,
		cntcr=0;
	while ( *ptr ) {
		if ( *ptr == '\r' || *ptr == '\n' ) {
			if ( *ptr == '\n' ) cntlf ++;
			else cntcr++;
			if ( cntlf > 1 && cntcr > 1 ) {
				ptr ++;
				break;
			}
		}
		else { cntlf = 0; cntcr = 0; }
		ptr ++;
	}
	
	return ptr;
}




