// MXResolver.h: interface for the CMXResolver class.
//
//////////////////////////////////////////////////////////////////////


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <winsock2.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>



struct DNSHEADER {
	short qryid;
    char options;
	char responses;
	short nqucount;
	short nancount;
	short naucount;
	short narcount;
};


class CMXResolver  
{
public:
	CMXResolver();
	virtual ~CMXResolver();

	void SetNameServer(char *server);
	char *MxQuery(char *domain);
	
private:
	char *m_server;
	char *m_domain;

	char m_best_mx[256];

	void MakeQName(const char *domain, char *qname);
	void GetMXName(char *buf, char *ret);
	char *ParseName (char *buf, int idx, char *sName);
	void PrintLastError();

};
