// tiklemoaDlg.h : header file
//

#if !defined(AFX_TIKLEMOADLG_H__86E89A64_5BAF_4596_A3CD_0EFF342F564E__INCLUDED_)
#define AFX_TIKLEMOADLG_H__86E89A64_5BAF_4596_A3CD_0EFF342F564E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "qDecoder.h"

/////////////////////////////////////////////////////////////////////////////
// CTiklemoaDlg dialog

class CTiklemoaDlg : public CDialog
{
// Construction
public:
	CTiklemoaDlg(CWnd* pParent = NULL);	// standard constructor


	void InitDefaultVars();
	void InitDB();
	void LoadConfiguration();
	char *GetConf( char *key );
	Q_Entry *qecon;

	CString m_HTTPHost;
	CString m_HTTPPort;
	CString m_HTTPPath;


	CString m_ID;
	CString m_PW;


	BOOL m_bLogin;

	void PING();
	BOOL AutoLogin();
	BOOL CheckLogin(const char *id, const char *pw);


// Dialog Data
	//{{AFX_DATA(CTiklemoaDlg)
	enum { IDD = IDD_TIKLEMOA_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTiklemoaDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTiklemoaDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnUserLogin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TIKLEMOADLG_H__86E89A64_5BAF_4596_A3CD_0EFF342F564E__INCLUDED_)
