
#ifndef __WINSOCK2LAYER_H_
#define __WINSOCK2LAYER_H_



#define WS2_E02			"WS2L: WSAStartup() ʱȭ "
#define WS2_E03			"WS2L:   "
#define WS2_E10			"WS2L: connect() Լ "
#define WS2_E12			"WS2L:   ߻"
#define WS2_E05			"WS2L:  ŸӾƿ  "
#define WS2_E06			"WS2L: ۽ ŸӾƿ  "
#define WS2_E31			"WS2L:  ۽ "
#define WS2_E40			"WS2L:   "
#define WS2_E402		"WS2L:   ŸӾƿ"
#define WS2_E403		"WS2L:   ŸӾƿ"
#define WS2_E404		"WS2L:   ŸӾƿ"
#define WS2_E405		"WS2L:   "

#define	WS2_TIMEOUT_CONNECTION	402
#define WS2_TIMEOUT_SEND		403
#define WS2_TIMEOUT_RECV		404
#define WS2_CONNECTION_LOST		405

#define WS2_MAXBUF		40960

class WinSock2Layer {
public:
	WinSock2Layer();
	~WinSock2Layer();


	void SetTimeout(int n=60000);
	void SetTimeoutConnection(int n=10000);
	void SetTimeoutSend(int n=50000);
	void SetTimeoutRecv(int n=40000);
	void SetLog(const char *path);
	void SetPort(int n);
	bool SetAddress(const char *address);
	int Connect();
	int Send(const char *message);
	const char *Recv();
	int Close();
	int GetErrorCode();
	const char *GetErrorString();

private:

	SOCKET _sock;
	SOCKADDR_IN _addrsvr;
	WSADATA _wsaData;
	int _bread;

	

	int _ec;
	char _errstr[256];
	char _address[256];
	int _timeout;
	int _timeout_connection;
	int _timeout_send;
	int _timeout_recv;
	int _port;
	char *_retstr;
	bool _bLog;
	const char *_path_log;
	void Log(char *format, ...);
};

#endif