#include "sqlite.h"

#define SQLITE_QUERY_TOO_LONG			30
#define SQLITE_QUERY_FAILED				40

class CSQLite {
public:
	CSQLite();
	~CSQLite();

	int connect(const char *_path);
	int close();
	int query(char *format, ...);
	const char *result(char *format, ...);

	int rows();
	int cols();
	int next();

	const char *field(const char *name);
	bool eof();


private:
	int _rc;
	int _rows;
	int _cols;
	int _cursor;
	char *_errmsg;
	char **_result;
	sqlite *_db;
	void _finish();
};

