// tiklemoaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tiklemoa.h"
#include "tiklemoaDlg.h"
#include "login.h"
#include "_sqlite.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTiklemoaDlg dialog

CTiklemoaDlg::CTiklemoaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTiklemoaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTiklemoaDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTiklemoaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTiklemoaDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTiklemoaDlg, CDialog)
	//{{AFX_MSG_MAP(CTiklemoaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(MNU_USER_LOGIN, OnUserLogin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTiklemoaDlg message handlers

BOOL CTiklemoaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	



	InitDefaultVars();
	LoadConfiguration();
	PING();
	AutoLogin();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTiklemoaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTiklemoaDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTiklemoaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/**
@note
	qfValue() Լ qDecoder ̺귯̴.
	 ̺귯 , ٲ  Ƿ  Ǵ   ؼ
	GetConf() Լ .
*/
char *CTiklemoaDlg::GetConf( char *key )
{
	return qfValue( qecon, key );
}

void CTiklemoaDlg::LoadConfiguration()
{
	qecon = qfDecoder( PATH_CONF );
	if ( qecon == NULL ) {
		AfxMessageBox(" ʽϴ.");
	}
	
	m_HTTPHost = GetConf( "host" );
	m_HTTPPort = GetConf( "port" );
	m_HTTPPath = GetConf( "path" );

}

/**
@todo
*/
void CTiklemoaDlg::PING()
{
	/**
	CProtocol p;
	CHTTPQuery h;

	const char *res	= h.Query(m_HTTPHost, m_HTTPPort, m_HTTPPath, p.Ping() );
	p.Set( res );
	if ( p.Error() ) {
	}
	*/
}


//@ ó  , ڵ α üũ
BOOL CTiklemoaDlg::AutoLogin()
{
	CSQLite db;
	db.connect( PATH_DB );
	m_ID = db.result("SELECT value FROM config WHERE key='id'");
	m_PW = db.result("SELECT value FROM config WHERE key='pw'");
	CString autologin = db.result("SELECT value FROM config WHERE key='autologin'");
	db.close();

	if ( !m_ID.IsEmpty() && !m_PW.IsEmpty() && autologin == "1" ) {
		//@  α
		if ( CheckLogin( m_ID, m_PW ) ) {
			m_bLogin = true;
			return TRUE;
		}
		else {
			m_bLogin = false;
			m_ID.Empty();
			m_PW.Empty();
		}
	}

	return FALSE;
}

BOOL CTiklemoaDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class


	// ޸
	qfFree( qecon );
	return CDialog::DestroyWindow();
}


/**
@note	α  ޾ ,
	-> αεǾ ִ üũ
	-> ̵,йȣ,ڵα Ǿ ִ üũϿ ̾α׸ .
	#3.0 ->  ̾α(αâ) .
	-> ̾α׷    local-db  ϰ  α üũѴ.
		--> α и  #3.0  ٽ Ѵ.
		--> α ̸ ׳ Ѵ.
*/
void CTiklemoaDlg::OnUserLogin() 
{
	// TODO: Add your command handler code here
	
	if ( m_bLogin ) {
		MessageBox("̹ αεǾ ֽϴ.\r\nα׾ƿ Ͻ  ٽ α Ͻʽÿ.", "[˸] α  ", MB_OK );
		return;
	}


	Login dlg;
	

	CSQLite db;
	db.connect( PATH_DB );
	const char *id = db.result("SELECT value FROM config WHERE key='id'");
	if ( id != NULL ) {
		dlg.m_ID = id;
		dlg.m_SaveID = 1;
	}
	const char *pw = db.result("SELECT value FROM config WHERE key='pw'");
	if ( pw != NULL ) {
		dlg.m_PW = pw;
		dlg.m_SavePW = 1;
	}
	CString autologin = db.result("SELECT value FROM config WHERE key='autologin'");
	if ( autologin == "1" ) dlg.m_AutoLogin = 1;
	db.close();



	int nResponse = dlg.DoModal();
	// α õϴ   .
	while ( nResponse == IDOK ) {
		//@ α  Ѵ.
		CSQLite db;
		db.connect( PATH_DB );
		if ( dlg.m_SaveID )
			db.query("REPLACE INTO config (key, value) VALUES('id','%s')", (LPSTR)(LPCTSTR)dlg.m_ID);
		else
			db.query("DELETE FROM config WHERE key='id'");
		if ( dlg.m_SavePW )
			db.query("REPLACE INTO config (key, value) VALUES('pw','%s')", (LPSTR)(LPCTSTR)dlg.m_PW);
		else
			db.query("DELETE FROM config WHERE key='pw'");
		if ( dlg.m_AutoLogin )
			db.query("REPLACE INTO config (key, value) VALUES('autologin','%d')", dlg.m_AutoLogin);
		else
			db.query("DELETE FROM config WHERE key='autologin'");
		db.close();

		//@  α
		if ( CheckLogin( dlg.m_ID, dlg.m_PW ) ) {
			m_bLogin = true;
			m_ID = dlg.m_ID;
			m_PW = dlg.m_PW;
			break;
		}
		//@ α  , ٽ õ
		nResponse = dlg.DoModal();
	} // eow
}



void CTiklemoaDlg::InitDefaultVars()
{
	m_bLogin	= FALSE;
	InitDB();
}

/**
	α  и ϴ Լ
@important @note
	ID   ּ ̶Ѵ.
	"@"  ִ  "/tikle/request.php"   HTTP URL ̴.

@return
	, TRUE
	н, FALSE
*/
BOOL CTiklemoaDlg::CheckLogin(const char *id, const char *pw)
{
	if ( id == NULL )
		MessageBox( "̵ ùٸ ʽϴ.","[] α ", MB_OK | MB_ICONWARNING );

	return FALSE;
}


void CTiklemoaDlg::InitDB()
{
		// DB 
	CSQLite db;
	db.connect( PATH_DB );

	// ̺ ϴ üũ
	char *q;
	q = "SELECT count(*) FROM sqlite_master WHERE type='table'";
	int cnt = atoi( db.result( q ) );
	if ( cnt != 0 ) {
		db.close();
		return;
	}

	//  ʴ´ٸ 
	q = "create table config (idx integer primary key, key char(64), value char(255))";
	db.query( q );
	db.query( "create unique index config_key on config(key)" );

	db.close();
	return;
}
